\RequirePackage[l2tabu, orthodox]{nag}
\documentclass[12pt]{amsart}
\usepackage{fullpage,url,amssymb,enumerate,colonequals,pdfsync,float,mathtools,appendix,float,amsmath}
% \usepackage[all]{xy} % for commutative diagrams
%\usepackage{mathrsfs} % for \mathscr (script letters)

\usepackage{listings}
\usepackage{rotating}
\newcommand*{\isoarrow}[1]{\arrow[#1,"\rotatebox{90}{\(\sim\)}"]}


\usepackage{tikz-cd,graphicx}

\newcommand{\defi}[1]{\textsf{#1}} % for defined terms



\makeatletter
\g@addto@macro\bfseries{\boldmath} % This makes math in section titles bold.
\makeatother

\usepackage{microtype}

%%% \renewcommand{\baselinestretch}{3}   % for triple spacing

\usepackage[
%	draft,
%	colorlinks,
backref,
pdfauthor={Solomon}, % add other authors
%	pdftitle={Paper title goes here},
]{hyperref}
\usepackage[alphabetic,backrefs,lite,nobysame]{amsrefs} % for bibliography

\usepackage{color}


\usepackage[framemethod=tikz]{mdframed}

\newcommand{\isaac}[1]{{\color{magenta} \textsf{$\spadesuit\spadesuit\spadesuit$ isaac: [#1]}}}

\newcommand{\blue}[1]{{\color{blue} #1}}
\newcommand{\magenta}[1]{{\color{magenta} #1}}
\newcommand{\green}[1]{{\color{ForestGreen} #1}}

\numberwithin{figure}{section}


\title{STATS 302: Homework 2}
\author{Elchanan Solomon}
\date{\today}

\begin{document}

	
	\maketitle
	\thispagestyle{empty}
	
\begin{enumerate}
	\item ISLR 3.7(3,4,7,11a-c,14). Hints:
	\begin{itemize}
		\item For (7), use Equation 3.4.
		\item For (11), you can use the following code to build the data:
				\begin{lstlisting}[language=Python]
	def f(x):
	return 2*x
	x = np.random.normal(0,1,100)
	y = [f(p) for p in x]
	y+= np.random.normal(0,1,100)
		\end{lstlisting}
		 you can use the following code to regress $Y$ on to $X$ without an intercept, and to return the statistics of the fit: 
			\begin{lstlisting}[language=Python]
		import statsmodels.api as sm
		res = sm.OLS(y,x).fit()
		print(res.summary())
		\end{lstlisting}
		\item For (14), you can use the following code to build the data:
		\begin{lstlisting}[language=Python]
		x1 = np.random.rand(100)
		x2 = 0.5*x1 + np.random.normal(0,1,100)/10
		y = 2+2*x1+0.3*x2 + np.random.normal(0,1,100) 
		\end{lstlisting}
		To regress with intercept, we need to add a constant variable that is constantly equal to $1$, and we package $x_1,x_2$ and the constant variable into a single array:
		 \begin{lstlisting}[language=Python]
		 X = np.ones((100,3))
		 X[:,0] = x1
		 X[:,1] = x2
		 \end{lstlisting}
		 To regress and plot the statistics:
		 \begin{lstlisting}[language=Python]
		 res = sm.OLS(y,X).fit()
		 print(res.summary())
		 \end{lstlisting}
	\end{itemize}
	 
	\item (Code): Let $y = 3x + 2 + \epsilon$, where $\epsilon \sim N(0,5)$. Randomly sample $10$ data points $(x,y)$ (it may be helpful to use \texttt{np.random.normal(0,5,10)}) and fit a linear model $y = \beta_1 x + \beta_0$. You can use the following python code:
	\begin{lstlisting}[language=Python]
	from scipy import stats
	beta1, beta0, r_val, p_val, std_err =stats.linregress(x,y)
	\end{lstlisting}
	It's unlikely that your estimated $\beta_1$ and $\beta_0$ will be $3$ and $2$, respectively. Repeat this experiment by sampling $10$ more points and fitting a new linear model, getting new estimates for $\beta_1$ and $\beta_0$. Repeat this $100$ times and average the values of $\beta_1$ and $\beta_0$ you observe. What do you get? How is this related to the concept of an \textbf{unbiased estimator}? Use \texttt{plt.hist} to plot a histogram of the values of $\beta_1$ and $\beta_0$ observed, and interpret what you see.
	\item (Code): Consider the following set of $x$ and $y$ values:
	\begin{verbatim}
	x =  [0.         0.07142857 0.14285714 0.21428571 0.28571429 0.35714286
	0.42857143 0.5        0.57142857 0.64285714 0.71428571 0.78571429
	0.85714286 0.92857143 1.        ]
	y =  [ 0.69294693  0.10017041  1.38496327 -0.22973041  0.83787727 -1.25086678
	0.67623999 -0.77116334  0.6697642   1.42074611  0.62037744  2.76302914
	1.63852124  2.17597781  3.19427353]
	\end{verbatim}
	Fit a linear model to $(x,y)$ and give a confidence interval for the slope parameter $\beta_1$. Do you accept or reject the null hypothesis that $\beta_1 = 0$? You can use the following snippet of code to compute the relevant statistical quantities:
		\begin{lstlisting}[language=Python]
	from scipy import stats
	slope, intercept, r_val, p_val, std_err =stats.linregress(x,y)
	\end{lstlisting}
\end{enumerate}
	

\end{document}